#include "i2c.h"
#include "delay.h"

// TODO: zakladne operacie s pinmi cez makra
// TODO: zoptimalizovat casovanie, delaye nie su nutne
// TODO: zoptimalizovat kod, je skaredy

#define SDA_PIN RB0
#define SCL_PIN RB1
#define SDA_DIR TRISB0
#define SCL_DIR TRISB1
#define DBG(v) //{TRISB4 = 0; RB4 = v; }

// interface

void i2c_init(void)
{
	i2c_high_scl();
	i2c_high_sda();
}

BYTE i2c_write(unsigned char b)
{
	i2c_out_byte(b);
	return i2c_nack();
}

BYTE i2c_read(unsigned char cont)
{
	unsigned char bRet;
	bRet = i2c_in_byte();
	if (cont)
		i2c_ack();
	else
		i2c_nack();
	return bRet;
}

// internal
byte i2c_in_byte(void)
{
   byte i_byte, n;
   i2c_high_sda();
   for (n=0; n<8; n++)
   {
      i2c_high_scl();

      if (SDA_PIN)
      {
         i_byte = (i_byte << 1) | 0x01; // msbit first
      }
      else
      {
         i_byte = i_byte << 1;
      }
      i2c_low_scl();
   }
   return(i_byte);
}

void i2c_out_byte(byte o_byte)
{
   byte n;
   for(n=0; n<8; n++)
   {
      if(o_byte&0x80)
      {
         i2c_high_sda();
      }
      else
      {
         i2c_low_sda();
      }
      i2c_high_scl();
      i2c_low_scl();
      o_byte = o_byte << 1;
   }
   i2c_high_sda();
}

byte i2c_nack(void)
{
   unsigned char ack = 0;
   i2c_high_sda();	// data at one
   i2c_high_scl();	// clock pulse
   ack = SDA_PIN;
   i2c_low_scl();
   return ack;
}

void i2c_ack(void)
{
   i2c_low_sda();	// bring data low and clock
   i2c_high_scl();
   i2c_low_scl();
   i2c_high_sda();
}


void i2c_start(void)
{
/*
   i2c_low_scl();
   i2c_high_sda();
   i2c_high_scl();	// bring SDA low while SCL is high
   i2c_low_sda();
   i2c_low_scl();
*/
   i2c_low_sda();
   i2c_low_scl();
}

void i2c_stop(void)
{
//   i2c_low_scl();
//   i2c_low_sda();
   i2c_high_scl();
   i2c_high_sda();  // bring SDA high while SCL is high
   // idle is SDA high and SCL high
}

void i2c_high_sda(void)
{
   // bring SDA to high impedance
   SDA_DIR = 1;
   DBG(1);
   DelayUs(50);
}

void i2c_low_sda(void)
{
   SDA_PIN = 0;
   SDA_DIR = 0;  // output a hard logic zero
   DBG(0);
   DelayUs(50);
}

void i2c_high_scl(void)
{
   SCL_DIR = 1;   // high impedance
   DelayUs(50);
}

void i2c_low_scl(void)
{
   SCL_PIN = 0;
   SCL_DIR = 0;
   DelayUs(50);
}
