// SerialComm.h: interface for the CSerialComm class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SERIALCOMM_H__D0A10092_8DEF_400E_920C_81292952B552__INCLUDED_)
#define AFX_SERIALCOMM_H__D0A10092_8DEF_400E_920C_81292952B552__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <math.h>


class CSerialComm  
{
	HANDLE hCom;
public:
	CSerialComm()
	{
		hCom = NULL;
	}
	virtual ~CSerialComm()
	{
		if (hCom != NULL)
			CloseHandle(hCom);
	}
	
	void Close()
	{
		if (hCom != NULL)
			CloseHandle(hCom);
		hCom = NULL;
	}

	BOOL IsValid()
	{
		return (hCom != NULL && hCom != INVALID_HANDLE_VALUE) ? TRUE : FALSE;
	}

	void Send( CString strString )
	{
		int i;
		char Buffer[1024];
		for (i=0; i < strString.GetLength(); i++)
			Buffer[i] = (char)strString[i];
		Buffer[i] = 0;

	  DWORD Pocet=strString.GetLength();

	  WriteFile(
				hCom,   // Handle portu, ktory ste otvorili CreateFile
				&Buffer,  // Smernik (pointer) na data, ktore chcem vysielat
				Pocet,      // Pocet bytov, ktore chcem vyslat
				&Pocet, // Smernik (pointer) na pocet vyslanych dat
				NULL);  // Musi byt NULL

	  if( Pocet != strString.GetLength() ) // Ak pocet prenesenych dat nesuhlasi    
	  {
		  MessageBox(NULL, _T("Chyba:  Nepodaril sa odoslat buffer."), _T("Chyba"), 0);
		  Close();
	  }
	}

	BOOL Receive( CString &strString )
	{
	  DWORD Pocet=0;            // Poc(et prijatch dt
	  char Buffer[1024];

	  //PurgeComm(hCom,PURGE_TXCLEAR | PURGE_RXCLEAR);

	  if (!ReadFile(
			   hCom,         // Handle portu, z ktorho c(tame
			   &Buffer,        // Pointer na buffer, kam ukladme prijat dta
			   1024,            // Poc(et bytov, na ktor c(akme
			   &Pocet,           // Pointer na skutoc(n poc(et prijatch dt
			   NULL))        // Mus byt( NULL
		  Close();


							 // Funkcia ReadFile tu teraz c(ak, a km niec(o 
							 // neprde, ale me aj skonc(it( bez zachytenho znaku, 
							 // ak medzitm vypria timeouty.

	  if( Pocet == 0 )      // Ak poc(et prenesench dt neshlas    
		  return FALSE;

	  strString = "";
	  for (int i=0; i<(int)Pocet; i++)
		  strString += CString(Buffer[i]);
	  return TRUE;
	}

	BOOL Init(CString strPort, long nBaud)
	{
 
		  hCom = CreateFile(                 
				 strPort,                         // Nzov portu, ktor otvrame
				 GENERIC_READ | GENERIC_WRITE,    // Otvrame na c(tanie aj na zpis
				 0,                               // Zdiel(anie nebude iadne
				 NULL,                            // Bezpec(nostn info iadne
				 OPEN_EXISTING,                   // Otvrame existujci (port)
				 0,                               // iadne atribty sboru
				 NULL);                           // Mus byt( NULL

		  if ( hCom == INVALID_HANDLE_VALUE )
		  {
			  MessageBox(NULL, _T("Chyba:  Port sa neda otvorit."), _T("Chyba"), 0);
			  return FALSE;
		  }


		 DCB PortDCB;                       // truktra, v ktorej s uloen parametre    
  
		 PortDCB.DCBlength = sizeof(DCB);  // Inicializuj poloku DCBlength
		 GetCommState(hCom,&PortDCB);       // Nac(taj aktulne nastavenia
		 //printf("\nBaud rate:       %d",PortDCB.BaudRate); 

		 PortDCB.BaudRate = nBaud;           // Zmenme nejak parameter v DCB

		 int err;
		 err = SetCommState(hCom,&PortDCB); // Nastav aktulne nastavenia na port
		 if(!err)   
		 {
			 MessageBox(NULL, _T("Chyba:  Port sa neda nakonfigurovat."), _T("Chyba"), 0);
			 return FALSE;
		 }


		 // vypis DCB do strInitInfo
	
		
	COMMTIMEOUTS timeouts;
   
  timeouts.ReadIntervalTimeout         = 1;

  timeouts.ReadTotalTimeoutMultiplier  = 1;
  timeouts.ReadTotalTimeoutConstant    = 1;

  timeouts.WriteTotalTimeoutConstant    = 1;
  timeouts.WriteTotalTimeoutMultiplier	= 1;
  
  
  if (!SetCommTimeouts(hCom,&timeouts))
	  MessageBox(NULL, _T("Nepodarilo sa nastavit timeouty."), _T("Chyba"), 0);
	return FALSE;

	return TRUE;

	
	}

};

#endif // !defined(AFX_SERIALCOMM_H__D0A10092_8DEF_400E_920C_81292952B552__INCLUDED_)
