//#include "stdafx.h"
#include <math.h>
#include "SerialComm.h"

class COGLMain
{
public:
	float m_fRotX, m_fRotY;
		GLUquadricObj *quadratic;
	CString strBuffer;
	CSerialComm m_Comm;

	void Init()
	{
		m_fRotX = 0;
		m_fRotY = 0;

			quadratic=gluNewQuadric();			// Create A Pointer To The Quadric Object ( NEW )
	gluQuadricNormals(quadratic, GLU_SMOOTH);	// Create Smooth Normals ( NEW )
	gluQuadricTexture(quadratic, GL_TRUE);		// Create Texture Coords ( NEW )

		for(int x=0; x<5; x++)
			for(int y=0; y<5; y++)
				for(int z=0; z<5; z++)
					map[x][y][z] = 0;
		for (int i=0; i<500; i++)
		{
			int x=rand()%4;
			int y=rand()%4;
			int z=rand()%4;
			map[x][y][z] ^= 1;
			map[x][y][z+1] ^= 1;
			map[x][y+1][z] ^= 1;
			map[x+1][y][z] ^= 1;
		}
		m_Comm.Init("COM7:", 9600);
		m_Comm.Send("r");
	}
	void Close()
	{
		gluDeleteQuadric(quadratic);
		m_Comm.Send("r");
		m_Comm.Close();
	}

	void OnDraw()
	{
	}
	void DrawScene()
	{
		static FLOAT f = 0;
		static int pmode = 0;
		static int pstep = 0;
		static CString pstring;

		CString strRecv;
		m_Comm.Receive(strRecv);
		for (int i=0; i<strRecv.GetLength(); i++)
		{
			switch ( strRecv[i] )
			{
			case 'h': pmode = 'h'; pstep = -1; break;
			case 'y': pmode = 'y'; pstep = -1; break;
			default:
				if ( pstep==-1 && strRecv[i] != '=')
					pmode = 0;
				if (pmode && pstep >= 0)
					pstring += strRecv[i];

				pstep++;
				if (pstep == 5)
				{
					switch (pmode)
					{
					case 'h':
						m_fRotX = -atoi(pstring.GetBuffer())*0.1f;
						break;
					case 'y':
						{
							int ny = 0;
							sscanf(pstring.GetBuffer(), "%x", &ny);
							m_fRotY = ((short)ny)*-0.2f;
						}
						break;
					}
					pmode = 0;
					pstring.Empty();
				}
			}
		}
		m_fRotY = cos(f)*10.0f;
		f += 0.1f;

		/*
		strBuffer += strRecv;
		strBuffer = strBuffer.Right(32);
		int nPos = strBuffer.Find(("h="));
		if ( nPos != -1 )
		{
			CString strHeading = strBuffer.Mid(nPos+2, 5);
			//m_fRotX = atoi(strHeading.GetBuffer())*180.0f/32768.0f;
			m_fRotX = atoi(strHeading.GetBuffer())*0.1f;
//			m_fRotX *= 3.141592f/180.0f;
		}
		nPos = strBuffer.Find(("y="));
		if ( nPos != -1 )
		{
			CString strY = strBuffer.Mid(nPos+2, 5);
			m_fRotY = atoi(strY.GetBuffer())*0.2f;
//			m_fRotX *= 3.141592f/180.0f;
		}*/

//		Rotate(0.1f, 0.073f);
			glClear(GL_COLOR_BUFFER_BIT |
			GL_DEPTH_BUFFER_BIT);

		glLoadIdentity();
		glTranslatef(0.0f, 0.0f, -10.0);

		glRotatef(m_fRotX, 0.0f, 1.0f, 0.0f);
		glRotatef(m_fRotY, cos(m_fRotX*3.1415/180), 0.0f, sin(m_fRotX*3.1415/180));
		float no_mat[] = {0.0f, 0.0f, 0.0f, 1.0f};
    float mat_ambient[] = {0.2f, 0.2f, 0.4f, 1.0f};
    float mat_ambient2[] = {0.2f, 0.4f, 0.2f, 1.0f};
    float mat_ambient_color[] = {0.8f, 0.8f, 0.2f, 1.0f};
    float mat_diffuse[] = {0.1f, 0.5f, 0.8f, 1.0f};
	float mat_diffuse2[] = {0.1f, 0.8f, 0.3f, 1.0f};
    float mat_specular[] = {1.0f, 1.0f, 1.0f, 1.0f};
    float no_shininess = 1.0f;
    float low_shininess = 5.0f;
    float high_shininess = 100.0f;
    float mat_emission[] = {0.3f, 0.2f, 0.2f, 0.0f};
  float ambient[] = {0.1f, 0.1f, 0.1f, 1.0f};
    float diffuse[] = {1.0f, 1.0f, 1.0f, 1.0f};
    float specular[] = {1.0f, 1.0f, 1.0f, 1.0f};
    float position[] = {1.0f, 1.0f, 0.3f, 0.0f};
	float model_ambient[] = {0.4f, 0.4f, 0.4f, 1.0f};
	int viewpoint = 0;
	    glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
    glLightfv(GL_LIGHT0, GL_POSITION, position);
		glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
		glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
        glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
        glMaterialf(GL_FRONT, GL_SHININESS, high_shininess);
        glMaterialfv(GL_FRONT, GL_EMISSION, no_mat);
   
		glLightModelfv(GL_LIGHT_MODEL_AMBIENT, model_ambient);  
		glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, viewpoint);
		glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, 1);
		glEnable(GL_LIGHT0);
		glEnable(GL_LIGHTING);
		glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);

		float sx[8], sy[8], sz[8];
		for (int z=0; z<5; z++)
			for (int y=0; y<5; y++)
				for (int x=0; x<5; x++)
				{
					float fx=x-2.0, fy=y-2.0, fz=z-2.0;
					// rotate by 
					//_rotate(fx, fy, fz, 0, m_fRotX, 0);
					//_rotate(fx, fy, fz, m_fRotY, 0, 0);

					if ( x<2 && y<2 && z < 2)
					{
						sx[x+y*2+z*4] = fx;
						sy[x+y*2+z*4] = fy;
						sz[x+y*2+z*4] = fz;
					}

					glPushMatrix();
					glTranslatef(fx, fy, fz);
					glMaterialfv(GL_FRONT, GL_DIFFUSE, map[x][y][z]?mat_diffuse:mat_diffuse2);
					glMaterialfv(GL_FRONT, GL_AMBIENT, map[x][y][z]?mat_ambient:mat_ambient2);

					gluSphere(quadratic,0.5f,8,8);
					glPopMatrix();
				}
			glDisable(GL_LIGHTING);

		_box(sx,sy,sz);
	}
	
	void Rotate(float x, float y)
	{
		float rz;
		//_rotate(m_fRotX, m_fRotY, rz, x, y, 0);
		
		m_fRotX += x;
		m_fRotY += y;
		if ((m_fRotX > 360.0f) || (m_fRotX < -360.0f))
		{
			m_fRotX = 0.0f;
		}
		if ((m_fRotY > 360.0f) || (m_fRotY < -360.0f))
		{
			m_fRotY = 0.0f;
		}
	}
	void _rotate(float &x, float &y, float &z, float a, float b, float c)
	{
		a *= 3.141592653/180.0;
		b *= 3.141592653/180.0;
		c *= 3.141592653/180.0;
		float nx=x, ny=y, nz=z;
		nx = x * cos(b) + z * sin(b);
		nz = - x * sin(b) + z * cos(b);
		x=nx; y=ny; z=nz;
		ny = y * cos(a) - z * sin(a);
		nz = y * sin(a) + z * cos(a);
		x=nx; y=ny; z=nz;
		nx = x * cos(c) - y * sin(c);
		ny = x * sin(c) + y * cos(c);
		x=nx; y=ny; z=nz;
	}
	void _box(float *x, float *y, float *z)
	{
		// Wireframe Mode
		//glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
		float vx[3]={x[1]-x[0], y[1]-y[0], z[1]-z[0]};
		float vy[3]={x[4]-x[0], y[4]-y[0], z[4]-z[0]};
		float vz[3]={x[2]-x[0], y[2]-y[0], z[2]-z[0]};
#define MU 0.5f
#define _ADD(p,v) x[p]+=v[0]*MU; y[p]+=v[1]*MU; z[p]+=v[2]*MU;
#define _SUB(p,v) x[p]-=v[0]*MU; y[p]-=v[1]*MU; z[p]-=v[2]*MU;
		
		_SUB(0, vx); _SUB(0, vy); _SUB(0, vz);
		_ADD(1, vx); _SUB(1, vy); _SUB(1, vz);
		_SUB(2, vx); _SUB(2, vy); _ADD(2, vz);
		_ADD(3, vx); _SUB(3, vy); _ADD(3, vz);

		_SUB(4, vx); _ADD(4, vy); _SUB(4, vz);
		_ADD(5, vx); _ADD(5, vy); _SUB(5, vz);
		_SUB(6, vx); _ADD(6, vy); _ADD(6, vz);
		_ADD(7, vx); _ADD(7, vy); _ADD(7, vz);

		int nblk[] = {0,1,3,2,1,5,7,3,4,5,7,6,0,4,6,2,0,1,5,4,2,3,7,6};
		int red[] = {0,1,2,3,4,5,6,7};
		 glEnable(GL_BLEND);	
		glColor4f(1.0, 1.0, 1.0, 0.2);
		  glBlendFunc(GL_SRC_ALPHA, GL_ONE);	
		glBegin(GL_QUADS);
		for (int i=0; i<6*4; i++)
			glVertex3f(x[red[nblk[i]]],  y[red[nblk[i]]], z[red[nblk[i]]]); 
		glEnd();
		float tx=0, ty=0, tz=0;
		for (int i=0; i<8; i++)
		{
			tx += x[i];ty += y[i];tz += z[i];
		}
		tx/=8.0f;ty/=8.0f;tz/=8.0f;
		glTranslatef(tx,ty,tz);
		gluSphere(quadratic,0.9f,12,12);
		//gluSphere(quadratic,1.2f,12,12);

		glDisable(GL_BLEND);	


	}
	int map[5][5][5];
};